# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'WorkspaceAccountAccessType',
    'WorkspaceAuthenticationProviderTypes',
    'WorkspaceDataSourceType',
    'WorkspaceNotificationDestinationType',
    'WorkspacePermissionType',
    'WorkspaceSamlConfigurationStatus',
    'WorkspaceStatus',
]


class WorkspaceAccountAccessType(str, Enum):
    """
    These enums represent valid account access types. Specifically these enums determine whether the workspace can access AWS resources in the AWS account only, or whether it can also access resources in other accounts in the same organization. If the value CURRENT_ACCOUNT is used, a workspace role ARN must be provided. If the value is ORGANIZATION, a list of organizational units must be provided.
    """
    CURRENT_ACCOUNT = "CURRENT_ACCOUNT"
    ORGANIZATION = "ORGANIZATION"


class WorkspaceAuthenticationProviderTypes(str, Enum):
    """
    Valid workspace authentication providers.
    """
    AWS_SSO = "AWS_SSO"
    SAML = "SAML"


class WorkspaceDataSourceType(str, Enum):
    """
    These enums represent valid AWS data sources that can be queried via the Grafana workspace. These data sources are primarily used to help customers visualize which data sources have been added to a service managed workspace IAM role.
    """
    AMAZON_OPENSEARCH_SERVICE = "AMAZON_OPENSEARCH_SERVICE"
    CLOUDWATCH = "CLOUDWATCH"
    PROMETHEUS = "PROMETHEUS"
    XRAY = "XRAY"
    TIMESTREAM = "TIMESTREAM"
    SITEWISE = "SITEWISE"
    ATHENA = "ATHENA"
    REDSHIFT = "REDSHIFT"


class WorkspaceNotificationDestinationType(str, Enum):
    """
    These enums represent valid AWS notification destinations that the Grafana workspace has permission to use. These notification destinations are primarily used to help customers visualize which destinations have been added to a service managed IAM role.
    """
    SNS = "SNS"


class WorkspacePermissionType(str, Enum):
    """
    These enums represent valid permission types to use when creating or configuring a Grafana workspace. The SERVICE_MANAGED permission type means the Managed Grafana service will create a workspace IAM role on your behalf. The CUSTOMER_MANAGED permission type means that the customer is expected to provide an IAM role that the Grafana workspace can use to query data sources.
    """
    CUSTOMER_MANAGED = "CUSTOMER_MANAGED"
    SERVICE_MANAGED = "SERVICE_MANAGED"


class WorkspaceSamlConfigurationStatus(str, Enum):
    """
    Valid SAML configuration statuses.
    """
    CONFIGURED = "CONFIGURED"
    NOT_CONFIGURED = "NOT_CONFIGURED"


class WorkspaceStatus(str, Enum):
    """
    These enums represent the status of a workspace.
    """
    ACTIVE = "ACTIVE"
    CREATING = "CREATING"
    DELETING = "DELETING"
    FAILED = "FAILED"
    UPDATING = "UPDATING"
    UPGRADING = "UPGRADING"
    DELETION_FAILED = "DELETION_FAILED"
    CREATION_FAILED = "CREATION_FAILED"
    UPDATE_FAILED = "UPDATE_FAILED"
    UPGRADE_FAILED = "UPGRADE_FAILED"
    LICENSE_REMOVAL_FAILED = "LICENSE_REMOVAL_FAILED"
