# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDBParameterGroupResult',
    'AwaitableGetDBParameterGroupResult',
    'get_db_parameter_group',
    'get_db_parameter_group_output',
]

@pulumi.output_type
class GetDBParameterGroupResult:
    def __init__(__self__, parameters=None, tags=None):
        if parameters and not isinstance(parameters, dict):
            raise TypeError("Expected argument 'parameters' to be a dict")
        pulumi.set(__self__, "parameters", parameters)
        if tags and not isinstance(tags, list):
            raise TypeError("Expected argument 'tags' to be a list")
        pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def parameters(self) -> Optional[Any]:
        """
        An array of parameter names and values for the parameter update.
        """
        return pulumi.get(self, "parameters")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Sequence['outputs.DBParameterGroupTag']]:
        """
        An array of key-value pairs to apply to this resource.
        """
        return pulumi.get(self, "tags")


class AwaitableGetDBParameterGroupResult(GetDBParameterGroupResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDBParameterGroupResult(
            parameters=self.parameters,
            tags=self.tags)


def get_db_parameter_group(d_b_parameter_group_name: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDBParameterGroupResult:
    """
    The AWS::RDS::DBParameterGroup resource creates a custom parameter group for an RDS database family


    :param str d_b_parameter_group_name: Specifies the name of the DB parameter group
    """
    __args__ = dict()
    __args__['dBParameterGroupName'] = d_b_parameter_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:rds:getDBParameterGroup', __args__, opts=opts, typ=GetDBParameterGroupResult).value

    return AwaitableGetDBParameterGroupResult(
        parameters=__ret__.parameters,
        tags=__ret__.tags)


@_utilities.lift_output_func(get_db_parameter_group)
def get_db_parameter_group_output(d_b_parameter_group_name: Optional[pulumi.Input[str]] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDBParameterGroupResult]:
    """
    The AWS::RDS::DBParameterGroup resource creates a custom parameter group for an RDS database family


    :param str d_b_parameter_group_name: Specifies the name of the DB parameter group
    """
    ...
